Whamcloud - gitweb
Add ".#*" to the list of files removed from the make dist target dir.
[fs/lustre-release.git] / lustrecvs
1 #!/bin/sh
2
3 LC_COLLATE="C"
4 progname="${0##*/}"
5
6 warn ()
7 {
8     [ "$1" ] && echo >&2
9     [ "$1" ] && echo "$progname: $1" >&2
10     [ "$1" ] && echo >&2
11 }
12
13 fatal ()
14 {
15     warn "$2"
16     exit "$1"
17 }
18
19 usage ()
20 {
21     cat <<EOF
22 Usage: $progname <lustretag>
23   where <lustretag> is a tag of the lustre-core module
24 EOF
25 }
26
27 if [ -z "$LUSTRECVS_UPDATED" ] ; then
28     echo "$progname: updating lustrecvs"
29     cvs up -l || fatal 1 "Error updating lustrecvs"
30     export LUSTRECVS_UPDATED=yes
31     exec "$0" "$@"
32 fi
33
34 [ "$1" = "-r" ] && shift
35
36 buildtag="HEAD"
37 lustretag="$1"
38 shift
39
40 if [ "$*" ] ; then
41     usage >&2
42     exit 1
43 fi
44
45
46 case "$lustretag" in
47     '')
48         warn "a lustretag is required."
49         usage >&2
50         exit 1
51         ;;
52     --help | -h)
53         usage
54         exit 0
55         ;;
56
57     # These releases did not get build tagged for them because they
58     # this build system didn't exist when they were tagged
59     v1_2_8|v1_4_0) 
60         buildtag="HEAD"
61         ;;
62         
63     v* | b_release*) buildtag=$lustretag ;;
64
65     # this is the branch table
66     # keep this list sorted alphabetically!
67
68     *)
69         buildtag="HEAD"
70         ;;
71
72 esac
73
74 error_modules=
75 cvs_cmd ()
76 {
77     dir="$1"
78     module="$2"
79     tag="$3"
80     cotag=""
81     update=""
82
83     if [ "$tag" = "HEAD" ] ; then
84         cotag=""
85         uptag="-A"
86     elif [ "$tag" ] ; then
87         cotag="-r $tag"
88         uptag="-r $tag"
89     else
90         # silently skip if no tag was specified
91         return
92     fi
93
94     if [ -d "$dir" ] ; then
95         echo "$progname: Updating $dir to $tag"
96         ( cd "$dir" && cvs up -dP $uptag )
97     else
98         echo "$progname: Checking out $dir from $tag"
99         cvs co -P $cotag -d "$dir" "$module"
100     fi
101     if [ $? != 0 ] ; then
102         error_modules="$dir $error_modules"
103     fi
104 }
105
106 cvs_cmd build lustre-build "$buildtag"
107
108 if [ -f build/buildcvs ] ; then
109     . build/buildcvs
110 else
111     fatal 1 "build/buildcvs does not exist; not updating other modules."
112 fi
113
114 if [ "$error_modules" ] ; then
115     fatal 1 "There were errors checking out the following directories: $error_modules"
116 fi